#ifndef _HIGHSCORE_H
#define _HIGHSCORE_H

typedef struct HS_List
{
	int numRecs;
	int sizeRec;
	void *data;
	int (*compar)(const void *a, const void *b);
} HS_List;

HS_List *HS_CreateList(int numRecs, int sizeRec, int (*compar)(const void *a, const void *b));
void HS_FreeList(HS_List *list);
void *HS_GetRecord(HS_List *list, int num);
void HS_SetRecord(HS_List *list, int num, void *rec);
void HS_AddRecord(HS_List *list, void *rec);
int HS_SaveList(HS_List *list, char *filename);
int HS_LoadList(HS_List *list, char *filename);

#endif
