#include "SDL.h"
#include "SDL_mixer.h"

#include <stdio.h>
#include <stdlib.h>

#include "highscore.h"
#include "sauna.h"

HS_List *highscores;

static SDL_Surface *arrowbuffer=NULL;

int mainMenu(void) {
	SDL_Event event;
	SDL_Rect crect,crect2;
	int x,y;
	int x1,y1,x2,y2;
	crect.x=9999;

	if(arrowbuffer==NULL) {
		arrowbuffer=SDL_CreateRGBSurface(screen->flags,cursor->w,cursor->h,screen->format->BitsPerPixel,screen->format->Rmask,screen->format->Gmask,screen->format->Bmask,screen->format->Amask);
	}
	SDL_BlitSurface(background,NULL,screen,NULL);
	surfaceGreyscale(screen);
	SDL_BlitSurface(mainmenu,NULL,screen,NULL);
	SDL_Flip(screen);
	while(1) {
		if(!SDL_WaitEvent(&event)) {
			fprintf(stderr,"Error occured while waiting for an event: %s\n",SDL_GetError());
			return -1;
		}
		switch(event.type) {
			case SDL_QUIT: return 3;
			case SDL_KEYDOWN:
				if(event.key.keysym.sym==SDLK_ESCAPE) return 3;
				break;
			case SDL_MOUSEMOTION:
				if(crect.x<screen->w)
					SDL_BlitSurface(arrowbuffer,NULL,screen,&crect);
				crect2=crect;
				crect.x=event.motion.x;
				crect.y=event.motion.y;
				crect.w=cursor->w;
				crect.h=cursor->h;
				if(crect.x+crect.w>screen->w) crect.w=screen->w-crect.x;
				if(crect.y+crect.h>screen->h) crect.h=screen->h-crect.y;
				if(crect.x<crect2.x) x1=crect.x; else x1=crect2.x;
				if(crect.y<crect2.y) y1=crect.y; else y1=crect2.y;
				if(crect.x+crect.w>crect2.x+crect2.w)
					x2=crect.x+crect.w;
				else
					x2=crect2.x+crect2.w;
				if(crect.y+crect.h>crect2.y+crect2.h)
					y2=crect.y+crect.h;
				else
					y2=crect2.y+crect2.h;
				SDL_BlitSurface(screen,&crect,arrowbuffer,NULL);
				SDL_BlitSurface(screen,&crect,arrowbuffer,NULL);
				SDL_BlitSurface(cursor,NULL,screen,&crect);
				SDL_UpdateRect(screen,x1,y1,x2-x1,y2-y1);
				break;
			case SDL_MOUSEBUTTONDOWN:
				x=event.button.x;
				y=event.button.y;
				if(x>=317 && x<=516)
					if(y>=114 && y<=176) return 0;
				if(x>=342 && x<=498)
					if(y>=177 && y<=233) return 1;
				if(x>=314 && x<=547)
					if(y>=237 && y<=295) return 2;
				if(x>=344 && x<=498)
					if(y>=303 && y<=361) return 3;
			default: break;
		}
	}
	return 0;
}

int highscoreMenu(void) {
	SDL_Event event;
	SDL_Rect crect,crect2;
	const char *title="    Nimi                 Heitot  Osumat  Prosentti  Perakkaiset  Aika      Kuumin";
	int x1,y1,x2,y2;
	crect.x=9999;

	SDL_BlitSurface(background,NULL,screen,NULL);
	surfaceGreyscale(screen);
	x1=screen->w/2-strlen(title)*4;
	y1=90;
	gprintf(x1,y1,title);
	y1+=16;
	for(x2=0;x2<10;x2++) {
		score *s;
		s = HS_GetRecord(highscores, x2);
		gprintf(x1,y1,"%.2d. %s",x2+1,s->name?s->name:"");
		gprintf(x1+27*8,y1,"%.3d",s->throws);
		gprintf(x1+35*8,y1,"%.3d",s->hits);
		gprintf(x1+43*8,y1,"%2.1f",s->throws?(s->hits*100)/(float)s->throws:0.0);
		gprintf(x1+56*8,y1,"%.3d",s->maxConsecutive);
		gprintf(x1+65*8,y1,"%dm%ds",s->time/60,s->time%60);
		gprintf(x1+75*8,y1,"%.1f C",s->maxTemperature);
		y1+=16;
	}
	SDL_Flip(screen);
	while(1) {
		if(!SDL_WaitEvent(&event)) {
			fprintf(stderr,"Error occured while waiting for an event: %s\n",SDL_GetError());
			return -1;
		}
		switch(event.type) {
			case SDL_QUIT: return 1;
			case SDL_KEYDOWN:
				if(event.key.keysym.sym==SDLK_RETURN || event.key.keysym.sym==SDLK_ESCAPE) return 0;
			case SDL_MOUSEMOTION:
				if(crect.x<screen->w)
					SDL_BlitSurface(arrowbuffer,NULL,screen,&crect);
				crect2=crect;
				crect.x=event.motion.x;
				crect.y=event.motion.y;
				crect.w=cursor->w;
				crect.h=cursor->h;
				if(crect.x+crect.w>screen->w) crect.w=screen->w-crect.x;
				if(crect.y+crect.h>screen->h) crect.h=screen->h-crect.y;
				if(crect.x<crect2.x) x1=crect.x; else x1=crect2.x;
				if(crect.y<crect2.y) y1=crect.y; else y1=crect2.y;
				if(crect.x+crect.w>crect2.x+crect2.w)
					x2=crect.x+crect.w;
				else
					x2=crect2.x+crect2.w;
				if(crect.y+crect.h>crect2.y+crect2.h)
					y2=crect.y+crect.h;
				else
					y2=crect2.y+crect2.h;
				SDL_BlitSurface(screen,&crect,arrowbuffer,NULL);
				SDL_BlitSurface(screen,&crect,arrowbuffer,NULL);
				SDL_BlitSurface(cursor,NULL,screen,&crect);
				SDL_UpdateRect(screen,x1,y1,x2-x1,y2-y1);
				break;
			case SDL_MOUSEBUTTONDOWN:
				return 0;
			default: break;
		}
	}
	return 0;
}

int helpMenu(void) {
	int stage,rval,x1,y1,x2,y2;
	SDL_Surface *help;
	SDL_Event event;
	SDL_Rect areas[]={{0,280,200,200},{581,225,106,19},{513,5,281,304},{5,5,181,112},{352,99,158,86}};
	SDL_Rect crect,crect2;

	crect.x=9999;

	help = loadPng("ohje.png");
	if(!help) {
		fprintf(stderr,"Can't load help.png\n");
		return 0;
	}
    SDL_SetColorKey(help,SDL_SRCCOLORKEY,*(Uint8*)help->pixels);

	SDL_BlitSurface(background,NULL,screen,NULL);
	SDL_BlitSurface(help,&areas[0],screen,&areas[0]);
	SDL_Flip(screen);
	stage=1;
	rval=0;
	while(stage) {
		if(!SDL_WaitEvent(&event)) {
			fprintf(stderr,"Error occured while waiting for an event: %s\n",SDL_GetError());
			return -1;
		}
		switch(event.type) {
			case SDL_QUIT: {stage=0; rval=1; break;}
			case SDL_MOUSEMOTION:
				if(crect.x<screen->w)
					SDL_BlitSurface(arrowbuffer,NULL,screen,&crect);
				crect2=crect;
				crect.x=event.motion.x;
				crect.y=event.motion.y;
				crect.w=cursor->w;
				crect.h=cursor->h;
				if(crect.x+crect.w>screen->w) crect.w=screen->w-crect.x;
				if(crect.y+crect.h>screen->h) crect.h=screen->h-crect.y;
				if(crect.x<crect2.x) x1=crect.x; else x1=crect2.x;
				if(crect.y<crect2.y) y1=crect.y; else y1=crect2.y;
				if(crect.x+crect.w>crect2.x+crect2.w)
					x2=crect.x+crect.w;
				else
					x2=crect2.x+crect2.w;
				if(crect.y+crect.h>crect2.y+crect2.h)
					y2=crect.y+crect.h;
				else
					y2=crect2.y+crect2.h;
				SDL_BlitSurface(screen,&crect,arrowbuffer,NULL);
				SDL_BlitSurface(screen,&crect,arrowbuffer,NULL);
				SDL_BlitSurface(cursor,NULL,screen,&crect);
				SDL_UpdateRect(screen,x1,y1,x2-x1,y2-y1);
				break;
			case SDL_KEYDOWN:
				if(event.key.keysym.sym==SDLK_ESCAPE) {stage=0; break;}
			case SDL_MOUSEBUTTONDOWN:
				if(stage>=sizeof(areas)/sizeof(SDL_Rect)) {
					stage=0;
				} else {
					SDL_BlitSurface(help,&areas[stage],screen,&areas[stage]);
					SDL_UpdateRects(screen,1,areas+stage);
					stage++;
				}

			default: break;
		}
	}
	SDL_FreeSurface(help);
	return rval;
}

int compare(const void *a, const void *b)
{
	const score *score1, *score2;

	score1 = (score*)a;
	score2 = (score*)b;

	if(score1->maxTemperature == score2->maxTemperature) return 0;
	return (score1->maxTemperature > score2->maxTemperature)?(-1):(1);	
}

void initHighscores(void)
{
	char fullpath[512];
#ifndef WIN32
	strcpy(fullpath,getenv("HOME"));
	strcat(fullpath,"/.sauna_highscore");
	HS_SaveList(highscores, fullpath);
#else
	strcpy(fullpath,".highscore");
#endif
	highscores = HS_CreateList(10, sizeof(score), &compare);
	HS_LoadList(highscores, fullpath);
}

void deInitHighscores(void)
{
#ifndef WIN32
	char fullpath[512];
	strcpy(fullpath,getenv("HOME"));
	strcat(fullpath,"/.sauna_highscore");
	HS_SaveList(highscores, fullpath);
#else
	HS_SaveList(highscores, ".highscore");
#endif
	HS_FreeList(highscores);
}

void newHighscore(char *name)
{
	score s;

	s.name[0]='\0';
	strncpy(s.name, name,sizeof(s.name));
	s.time = gameStart / 1000;
	s.maxConsecutive = maxConsecutive;
	s.hits = hits;
	s.throws = throws;
	s.maxTemperature = maxTemperature;

	HS_AddRecord(highscores, &s);
}

float getLastScore(void)
{
	score *s;

	s = HS_GetRecord(highscores, 9);
	return s->maxTemperature;
}
